    
/* Common asm-only function for getv, setv.
 * INPUT:
 * s0 = uint8_t *sieve
 *    = result
 * s1 = index_t v, LO
 * s2 = index_t v, HI
 * OUTPUT:
 * s0 = &sieve[v >> 3]
 * s1 = (v & 0x07)
 */
    .section ".text.getv_setv_init","ax",@progbits
getv_setv_init:
    load s5, s1         ; s5 = LO(v)
    sr0  s2
    sra  s5
    sr0  s2
    sra  s5
    sr0  s2             ; 
    sra  s5             ; s2:s5 = (v >> 3)
    and  s1, 0x07       ; s1 = (v & 0x07)
    add  s0, s5         ; s0 = &sieve[v >> 3]
    return

/**
 * uint8_t getv(uint8_t *sieve, index_t v)
 * Returns 1 if the given value 'v' is known NOT be to a prime.
 *
 * s0 = uint8_t *sieve
 *    = result
 * s1 = index_t v, LO
 * s2 = index_t v, HI
 *
 * s3, s4, s5, s6, s7, sD = free to use
 * s8, s9, sA, sB, sC, sE, sF = save before use
 */
    .section ".text._getv","ax",@progbits
    .global _getv
_getv:
    ; return (sieve[v >> 3] >> (v & 0x07)) & 1;
    call getv_setv_init
    fetch s0, s0        ; s0 = sieve[v >> 3]
    
    ; shift s0 right by s1 bits
    compare s1, 0
    jump .Z, L2
L1: ; body
    sr0  s0
    sub  s1, 1
    jump .NZ, L1

L2: ; shift right done;
    and  s0, 1
    return

/**
 * void setv(uint8_t *sieve, index_t v)
 * Set a flag for the given value 'v' indicating it is NOT a prime.
 *
 * s0 = uint8_t *sieve
 * s1 = index_t v, LO
 * s2 = index_t v, HI
 *
 * s3, s4, s5, s6, s7, sD = free to use
 * s8, s9, sA, sB, sC, sE, sF = save before use
 */
    .section ".text._setv","ax",@progbits
    .global _setv
_setv:
    ; sieve[v >> 3] |= 1 << (v & 0x07);
    call getv_setv_init
    
    ; 1 << (v & 0x07);
    load s4, 1
    compare s1, 0
    jump .Z, L11
L12: ;body
    sl0  s4
    sub  s1, 1
    jump .NZ, L12

L11: ;end
    ; s4 = 1 << (v & 0x07);
    fetch s3, s0        ; s3 = sieve[v >> 3]
    or    s3, s4
    store s3, s0
    return
