library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

package comp_kcpsm3 is

-- program counter width
constant KCPSM3_PC_WIDTH : integer := 10;
-- instruction width
constant KCPSM3_INSTR_WIDTH : integer := 18;

component kcpsm3 is
    Port (      address : out std_logic_vector(KCPSM3_PC_WIDTH-1 downto 0);
            instruction : in std_logic_vector(KCPSM3_INSTR_WIDTH-1 downto 0);
                port_id : out std_logic_vector(7 downto 0);
           write_strobe : out std_logic;
               out_port : out std_logic_vector(7 downto 0);
            read_strobe : out std_logic;
                in_port : in std_logic_vector(7 downto 0);
              interrupt : in std_logic;
          interrupt_ack : out std_logic;
                  reset : in std_logic;
                    clk : in std_logic);
end component kcpsm3;
    
end package comp_kcpsm3;

package body comp_kcpsm3 is
end package body comp_kcpsm3;
