library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

package comp_kcpsm6 is

-- program counter width
constant KCPSM6_PC_WIDTH : integer := 12;
-- instruction width
constant KCPSM6_INSTR_WIDTH : integer := 18;

component kcpsm6 is
  generic(                 hwbuild : std_logic_vector(7 downto 0) := X"00";
                  interrupt_vector : std_logic_vector(11 downto 0) := X"3FF";
           scratch_pad_memory_size : integer := 64);
  port (                   address : out std_logic_vector(11 downto 0);
                       instruction : in std_logic_vector(17 downto 0);
                       bram_enable : out std_logic;
                           in_port : in std_logic_vector(7 downto 0);
                          out_port : out std_logic_vector(7 downto 0);
                           port_id : out std_logic_vector(7 downto 0);
                      write_strobe : out std_logic;
                    k_write_strobe : out std_logic;
                       read_strobe : out std_logic;
                         interrupt : in std_logic;
                     interrupt_ack : out std_logic;
                             sleep : in std_logic;
                             reset : in std_logic;
                               clk : in std_logic);
  end component kcpsm6;
    
end package comp_kcpsm6;

package body comp_kcpsm6 is
end package body comp_kcpsm6;
