#!/bin/bash
# 
# PBlaze simulator
#

PBVER=$1
IMEMFNAME=$2
TIMEOUT=1000

if [ -z "PBVER" -o -z "$IMEMFNAME" ]; then
    echo "ERROR: Must specify processor type and program memory file (.mem)"
    echo "Usage: $0 <pbtype> <prg.mem>"
    echo "  pbtype = {kcpsm3, pb3a}"
    exit 1
fi

echo "MCPU =" $PBVER
echo "Program =" $IMEMFNAME
echo "Timeout =" $TIMEOUT us
echo

vsim pbsim -Gimem_fname="$IMEMFNAME" -Gpbver="$PBVER" <<EOF
set NumericStdNoWarnings 1
set StdArithNoWarnings 1
run $TIMEOUT us
quit -f
EOF
